/*****************************************************************************
 * colorspace.h: colorspace functions and definitions
 *****************************************************************************
 * $Id: colorspace.h,v 1.3 2004/03/01 21:27:17 alainjj Exp $
 *****************************************************************************
 * Copyright (C) 1998 Gerd Knorr <kraxel@cs.tu-berlin.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/
#ifndef _COLORSPACE_H_
#define _COLORSPACE_H_
typedef void (*color_conv) (unsigned char *d, unsigned char *s, int w, int h);

/* ------------------------------------------------------------------- */
/* RGB conversions                                                     */

void swap_rgb16 (char *mem, int n);
void swap_rgb24 (char *mem, int n);
void swap_rgb32 (char *mem, int n);
void rgb24_to_bgr24 (char *dest, char *src, int w, int h);
void rgb24_to_rgb32 (unsigned char *dest, unsigned char *src, int w, int h);
void rgb32_to_rgb24 (unsigned char *dest, unsigned char *src, int w, int h);

/* ------------------------------------------------------------------- */
/* YUV conversions                                                     */

void packed422_to_planar422 (unsigned char *d, unsigned char *s, int w,
                 int h);
void packed422_to_planar411 (unsigned char *d, unsigned char *s, int w,
                 int h);
#endif // _COLORSPACE_H_
