/*****************************************************************************
 * plugin.h: xawdecode plugin interface
 *****************************************************************************
 * $Id: plugin.h,v 1.3 2003/08/28 19:36:11 alainjj Exp $
 *****************************************************************************
 * Copyright (C) 2001 Keuleu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/
#ifndef _PLUGIN_H_
#define _PLUGIN_H_

struct plugin_t {
  Boolean (* ui_init) (XtAppContext context, Widget main_shell, Widget tv_shell);
  int     (* set_idle_grabdisplay) (void **func);
  int     (* parse_cmdline) (int *j, char **argv);
  int     (* create_windows) (Widget shell);
  int     (* add_entry) (Widget paned);
  int     (* close) (void);
  int     (* set_channel) (struct CHANNEL *channel);
  char *  (* use_alternate) (void);
  int     (* init_colors) (int *p_bpp);
  int     (* read_config) (int *lcount, char *tag, char *val, int nr, char *filename);
  int     (* save_config) (FILE *fp);
  int     (* do_command) (char **l_tok);
  int     (* pre_config_init) (void);
  int     (* post_config_init) (void);
  int     (* get_ybar) (void);
  int     (*display_help_message) (FILE *fp);
  int     (*record_movie) (int flag);
  int     (*is_nagraudio_used) (void);
  void    (*wait_write_audio) (void);
  //int     (* get_vbifd) (void);
};
typedef struct plugin_t PLUGIN;

#endif // _PLUGIN_H_
